### FUNCTIONS AND PACKAGES ####
library("ggplot2")
library("dplyr")
library("reshape2")
library("mvtnorm")
library("furrr")
library("future")
Logit<-function(r)log(r/(1-r))
InvLogit<-function(z)exp(z)/(exp(z)+1)
options(dplyr.summarise.inform = FALSE)
MakeGriddedEstimates<-function(indata,logTrans=F,age=NULL,length=NULL,rm.outliers = FALSE){
  #print(age)
  #hh<<-indata
  #age and length must correspond to indata$acats or indata$lcats, respectively
  gridids<-unique(indata$gridid)
  #print(gridids)
  y<-n<-nNA<-ysd<-v<-ytot<-ysdtot<-vtot<-c()
  totd<-indata$d#This wil be equal if not length or age is a subset
  age.sampled<-NULL # irrelevant
  length.sampled<-NULL # irrelevant
  if(is.null(age) & is.null(length)){
    indata$du<-indata$d
    pvec<-rep(1,length(indata$du))
    
  }else{
    if(!is.null(age) & is.null(length)){
      #	print("99")
      ageid<-match(age,indata$acats)
      #	print("ageid")
      #	print(ageid)
      #tmp<-lapply(indata$Nalist,FUN=getAfun,ageid=ageid)
      #OOBS indata$Nalist is scaled to density!!!!
      tmp<-lapply(indata$Nalist,FUN=getAfun,ageid=age)
      #tmpp<-lapply(indata$palist,FUN=getAfun,ageid=1:length(indata$acats))
      tmpp<-lapply(indata$palist,FUN=getAfun,ageid=age)
      #	print("tmpp")
      #hh<<-tmpp
      age.sampled<-unlist(lapply(indata$Nalist, function (x) sum(unlist(x))))
      
    }
    if(is.null(age) & !is.null(length)){
      ageid<-match(length,indata$lcats)
      ageid<-ageid[!is.na(ageid)]
      #OOBS indata$Nllist is scaled to density!!!!
      #tmp<-lapply(indata$Nallist,FUN=getLfun,ageid=ageid)
      tmp<-lapply(indata$Nllist,FUN=getAfun,ageid=ageid)
      #tmpp<-lapply(indata$pllist,FUN=getAfun,ageid=1:length(indata$lcats))
      tmpp<-lapply(indata$pllist,FUN=getAfun,ageid=ageid)
      
      length.sampled<-unlist(lapply(indata$Nllist, function (x) sum(unlist(x))))
      
    }
    if(!is.null(age) & !is.null(length)){stop("Cannot extract for both age- and lenth-groups!")}
    indata$du<-unlist(tmp)
    #pvec<-unlist(tmpp)
    #pvec<-pvec/totd
    pvec<-unlist(tmpp)
  }
  if(logTrans)indata$du<-log(indata$du)
  
  if(rm.outliers ==TRUE){
    indata$du>(sort(indata$du,decreasing = TRUE)[2]*4)}else{rm.outl<-TRUE}
  
  dW<-indata$WC/indata$DIST
  #hh1<<-indata
  W<-nNAW<-vW<-wsd<-c()
  #print("WTF")
  for(i in 1:length(gridids)){ 
    #Subset
    tmpN<-indata$du[indata$gridid==gridids[i] & rm.outl]
    #cat(i," ")
    #hu<<-tmpN
    #total
    tmptot<-totd[indata$gridid==gridids[i] & rm.outl]
    if(!is.null(age.sampled)){ 
      tmpAged<-age.sampled[indata$gridid==gridids[i] & rm.outl]
    }
    if(!is.null(length.sampled)){ 
      tmpLength<-length.sampled[indata$gridid==gridids[i] & rm.outl]
    }
    
    tmpp<-pvec[indata$gridid==gridids[i] & rm.outl] 
    
    ytot[i]<-mean(tmptot) 
    
    if(!is.null(age) | !is.null(length)){
      if(!is.null(age)){
        if(is.null(age.sampled)){
          useid<-(1:length(tmpp))[!is.na(tmpp)]}else{
            useid<-(tmpAged != 0)}}
      
      if(!is.null(length)){
        if(is.null(length.sampled)){
          useid<-(1:length(tmpp))[!is.na(tmpp)]}else{
            useid<-(tmpLength != 0 & !is.na(tmpLength))}}
      
      #Estimates yi based on available data applied on the total (complete data)
      if(sum(tmptot[useid]) == 0){y[i]<-sum(tmptot[useid])}else{
        y[i]<-sum(tmptot[useid]*tmpp[useid])/sum(tmptot[useid])
        y[i]<-y[i]*ytot[i]}
    }else{y[i]<-ytot[i]
    useid<-TRUE}#mean(tmp)
    
    
    n[i]<-length(tmptot)
    nNA[i]<-sum(is.na(tmpp))
    vtot[i]<-var(tmptot)
    v[i]<-var(tmpN[useid])
    ysd[i]<-sqrt(v[i]/(n[i]-nNA[i]))
    ysdtot[i]<-sqrt(vtot[i]/n[i])
    #Biomass...
    tmpdW<-dW[indata$gridid==gridids[i]]
    W[i]<-mean(tmpdW,na.rm=T)
    nNAW[i]<-sum(is.na(tmpdW))
    vW[i]<-var(tmpdW,na.rm=T)
    wsd[i]<-sqrt(vW[i]/(n[i]-nNAW[i]))
  }
  y[ytot==0]<-0
  #W[ytot==0]<-0
  out<-data.frame(gridid=gridids,mu=y,n=n,nNA=nNA,se=ysd,v=v,mutot=ytot,setot=ysdtot,vtot=vtot,dw=W,sedw=wsd,vw=vW,nNAw=nNAW)
  out
}

getAfun<-function(x,ageid){
  xid<-1:length(x)
  #ageid outside xid? Insert 0's
  tmpx<-rep(0,length(1:max(ageid,xid)))
  tmpx[xid]<-x
  x<-tmpx
  sum(x[ageid])
}
future::plan(multiprocess)

# Correlation of time series with a minimum number of overlapping years
cor.overlap <- function(data, n = 3) {
  
  # Correlation
  cor.data <- cor(data, use="pairwise.complete.obs")
  diag(cor.data) <- NA
  
  # Calculate number of overlapping years between time series
  overlap <- matrix(NA, nrow=ncol(data), ncol=ncol(data))
  
  for(i in 1:ncol(data)) {
    for(j in 1:ncol(data)) {
      overlap[i, j] <- sum(complete.cases(data[,i], data[,j]))
    }
  }
  
  # Correlations set to NA if number of overlapping years between time series is below the threshold
  cor.data[overlap < n] <- NA
  
  # Melt
  output <- reshape2::melt(cor.data)
  
  return(list(Output=output, Overlap=overlap))
}

ExtractGridEst2<-function(path="D:/LastLast/TemperatureSynchrony/Chapter3/Data/Data/",art,suffix=NULL,yrs,grid_LL,logTrans=F,age=NULL,length=NULL,smaller=NULL,biomass=F, rm.outliers = FALSE){ 
  require(rgeos)
  require(raster)
  
  #if biomass=F: extracts biomass
  #else:
  #if smaller=NULL: not used
  #if smaller=T uses lcats smaller than "length"
  #if smaller=F uses lcats larger or equal than "length"
  gests<-list()
  ncount<-c()
  loadpath<-paste(path,art,"/",sep="")
  #Make list with density estimates per grid cell
  #print("wtf0")
  if(!is.null(length)){print(length)}
  if(!is.null(age)){cat("...", age, "...",sep = "")}
  for(y in 1:length(yrs)){
    loadname<-paste(art,suffix,yrs[y],sep="")
    loadfile<-paste(loadpath,loadname,sep="")
    #print("wtf1")
    #print(paste("Years Completed",y, "/", length(yrs)))
    #print(loadfile)
    #tmp<-load(loadfile,env=.GlobalEnv)
    ###
    #tmp<-load(loadfile,env=e<-new.env())
    #impdat<-e$impdat
    ###
    
    tmp<-load(loadfile)
    
    #print(tmp)
    #print("wtf")
    kkkk<<-impdat
    #if(is.list(impdat))impdat<-impdat$dat
    #Convert x y to spatial points
    spts<-SpatialPoints(data.frame(x=impdat$x,y=impdat$y),proj4string=CRS("+proj=longlat +ellps=WGS84"))
    #Find which cell they belongs to
    if(!is.null(grid_LL)){
      gridid<-as.vector(unlist(over(spts,grid_LL,returnList=T)))
      impdat$gridid<-gridid
    }else impdat$gridid<-1
    if(!is.null(smaller)){
      if(smaller) lengthu<-impdat$lcats[impdat$lcats<length]
      else lengthu<-impdat$lcats[impdat$lcats>=length]
    }else lengthu<-length
    gests[[y]]<-MakeGriddedEstimates(indata=impdat,logTrans=logTrans,age=age,length=lengthu, rm.outliers)
    #print(gests[[y]]$mu)
    ncount[y]<-length(impdat$d)
  }
  #gg<<-gests
  #Create time series for each grid cell in data
  gridcells<-NULL
  for(i in 1:length(gests))gridcells<-unique(c(gridcells,gests[[i]]$gridid))
  #print(gridid)	
  #Construct matrix with columns as gridcells
  dmatrix<-nmatrix<-sematrix<-vmatrix<-matrix(NA,nrow=length(yrs),ncol=length(gridcells))
  #dimnames(dmatrix)[[1]]<-1985:2015
  dimnames(dmatrix)[[1]]<-yrs
  dimnames(dmatrix)[[2]]<-gridcells
  dimnames(nmatrix)<-dimnames(sematrix)<-dimnames(vmatrix)<-dimnames(dmatrix)
  #print(dmatrix)
  #k0<<-gests
  #k1<<-dmatrix
  #Fill in...
  for(i in 1:length(gests)){
    #matchid<-match(1:10,c(3,1))
    #matchid<-match(as.numeric(colnames(dmatrix)),gests[[i]]$gridid)
    #matchid<-matchid[!is.na(matchid)]
    matchid<-match(gests[[i]]$gridid,as.numeric(colnames(dmatrix)))
    if(!biomass){
      #dmatrix[i,matchid]<-gests[[i]]$mu
      #if(is.null(smaller))nmatrix[i,matchid]<-gests[[i]]$n
      #else nmatrix[i,matchid]<-gests[[i]]$n-gests[[i]]$nNA
      #sematrix[i,matchid]<-gests[[i]]$se
      #vmatrix[i,matchid]<-gests[[i]]$v
      dmatrix[i,paste(gests[[i]]$gridid)]<-gests[[i]]$mu
      if(is.null(smaller))nmatrix[i,paste(gests[[i]]$gridid)]<-gests[[i]]$n
      else nmatrix[i,paste(gests[[i]]$gridid)]<-gests[[i]]$n-gests[[i]]$nNA
      sematrix[i,paste(gests[[i]]$gridid)]<-gests[[i]]$se
      vmatrix[i,paste(gests[[i]]$gridid)]<-gests[[i]]$v
      
    }
    else{
      dmatrix[i,matchid]<-gests[[i]]$dw
      nmatrix[i,matchid]<-gests[[i]]$n-gests[[i]]$nNAw
      sematrix[i,matchid]<-gests[[i]]$sedw
      vmatrix[i,matchid]<-gests[[i]]$vw
    }
  }
  #print("H?")
  #rm cells with no data
  #usecol<-colSums(!is.na(dmatrix))>0
  usecol<-1:ncol(dmatrix)
  #print(usecol)
  #if(usecol==1){
  if(sum(usecol)==1){
    dmatrix<-dmatrix[,usecol,drop=F]
    nmatrix<-nmatrix[,usecol,drop=F]
    sematrix<-sematrix[,usecol,drop=F]
    vmatrix<-vmatrix[,usecol,drop=F]
    #Set n-values in cells with no data 0
    nmatrix[is.na(nmatrix)]<-0
  }
  else{
    dmatrix<-dmatrix[,usecol]
    nmatrix<-nmatrix[,usecol]
    sematrix<-sematrix[,usecol]
    vmatrix<-vmatrix[,usecol]
    #Set n-values in cells with no data 0
    nmatrix[is.na(nmatrix)]<-0
  }
  #Extract corresponding positions
  #print("0")
  #print(dmatrix)
  if(!is.null(grid_LL))pts_LL<-gCentroid(grid_LL,byid=T)
  else pts_LL<-NULL
  #print("1")
  
  #extract correspondig distance matrix (in meters)
  #xyid<-match(colnames(dmatrix),as.numeric(rownames(coordinates(hex_pts_LL))))
  if(dim(dmatrix)[2]>1){
    #print("akafat")
    xyid<-match(colnames(dmatrix),as.numeric(rownames(coordinates(pts_LL))))
    #print(xyid)
    #xyid<-xyid[!is.na(xyid)]
    #xyptsu<-coordinates(hex_pts_LL)[xyid,]
    xyptsu<-coordinates(pts_LL)[xyid,]
    xyptsu_LL <- SpatialPoints(data.frame(x=xyptsu[,1],y=xyptsu[,2]),proj4string=CRS("+proj=longlat +ellps=WGS84"))
    
    LLmat<-coordinates(xyptsu_LL)
    k0<<-LLmat
    #distmat<-NULL
    
    xyptsu_LL.UTM37<- spTransform(xyptsu_LL, CRS("+proj=utm +zone=37 +datum=WGS84 +units=km +no_defs"))
    
    
    distmat<-pointDistance(xyptsu_LL.UTM37)
    #distmat<-pointDistance(LLmat,lonlat=T)
    #distmat[is.na(distmat)]<-0
    #distmat<-distmat+t(distmat)
    distmat*1000
  }
  else{
    distmat<-NULL
    LLmat<-NULL
  }
  
  list(dmatrix=dmatrix,nmatrix=nmatrix,sematrix=sematrix,vmatrix=vmatrix,distmat=distmat,LLmat=LLmat)
}

# # Gaussian synchrony equation
# GaussSyncE <- function(rho.0, rho.inf, x, lambda){ 
#   (rho.0-rho.inf)*exp(-(x^2)/(2*lambda^2)) + rho.inf 
# }

# Gaussian synchrony functions
par.boot <- function(data, zu ,rho.0, rho.inf, lambda, bt) {
  # bt: number of bootstrap replicates
  # rho.0: estimate for rho.0
  # rho.inf: estimate for rho.inf
  # lambda: estimate for lambda
  # start.val: starting values for optimizer
  # Parameters estimated by MLE model
  # bt<-100 
  # rho.0 <- X$rho.0 # estimate for rho.0
  # rho.inf <- X$rho.inf # estimate for rho.inf
  # lambda <- X$lambda # estimate for lambda
  
  #distmatsel <- test.distmati
  sigma <- (rho.0-rho.inf)*exp(-(zu^2)/(2*lambda^2)) + rho.inf
  diag(sigma) <- 1
  
  boot <- list()
  for(i in 1:bt){
    repb <- rmvnorm(nrow(data), rep(0, nrow(sigma)), sigma) 
    # Draw random numbers from multivariate normal distribution 
    # defined by rho.0, rho.inf and lambda
    repb[is.na(data)] <- NA # Remove values that are NA in original dataset
    boot[[i]] <- repb
  }
  return(boot)
  
}

GaussSyncF <- function(par, x, distmat, startVal=FALSE){
  # x: standardized
  
  rho.0 <- exp(par[1])/(1+exp(par[1]))
  rho.inf <- rho.0*exp(par[2])/(1+exp(par[2]))    
  lambda <- exp(par[3])
  if (startVal){
    cat(round(c(rho.0, rho.inf, lambda)),3)
  }
  logLL <- 0
  for (i in 1:nrow(x)){
    xx <- x[i,]
    sel <- !is.na(xx)
    distmatsel <- distmat[sel,sel]
    xx <- xx[sel]
    if(sum(sel)>2){
      mu <- rep(0, length(xx))
      sigma <- (rho.0-rho.inf)*exp(-(distmatsel^2)/(2*lambda^2)) + rho.inf
      diag(sigma) <- 1
      logLL <- logLL + -sum(dmvnorm(xx, mu, sigma,log = TRUE))}
  }
  logLL
}
boot.optim <- function(x){
  f0 <- optim(start.val, GaussSyncF, distmat=zu.temp, x=x)
  partabs<-f0$par
  #partabs<-c(f0$par,f1S$par)
  
  names(partabs)<-c("logitrho0","logitrhoinf","logl")
  partabs<-partabs[c("logl","logitrho0","logitrhoinf")]
  partabs<-t(partabs)
  #pb$tick()$print()
  return(partabs)
}

####################################################################################################
####################################################################################################

lls<-function(pars,x,distmat){
  r0<-InvLogit(pars[1])
  #rInf<-InvLogit(pars[2])
  rInf<-InvLogit(pars[1])*InvLogit(pars[2])
  l<-exp(pars[3])
  #s2<-exp(pars[4])
  
  n<-nrow(x)
  if(n==1)x<-x-mean(x,na.rm=T)
  else x<-x-matrix(rep(colMeans(x,na.rm=T),n),ncol=nrow(distmat),byrow=T)
  
  ll<-0
  
  for(i in 1:n){
    xi<-x[i,]
    useid<-!is.na(xi)
    xiu<-xi[useid]
    distmatsel<-distmat[useid,useid]
    if(sum(useid)>2){
      mu <- rep(0, length(xiu))
      #sigma<-s2*(rInf+(r0-rInf)*exp(-distmatsel^2/(2*l^2)))
      sigma<-rInf+(r0-rInf)*exp(-distmatsel^2/(2*l^2))
      diag(sigma) <- 1
      
      ll <- ll + -sum(dmvnorm(xiu, mu, sigma,log = TRUE))
    }
  }
  ll
}
boot.nlminb <- function(x){
  f0<-nlminb(start.val,lls,x= x,distmat=zu.temp,lower=lower,upper=upper)
  #  f1S<-nlminb(c(Logit(.4),log(150),log(10)),lls0,x=t(colMeans(x,na.rm=T)),z=zu,lower=lower,upper=upper)
  partabs<-f0$par
  #partabs<-c(f0$par,f1S$par)
  
  names(partabs)<-c("logitrho0","logitrhoinf","logl")
  partabs<-partabs[c("logl","logitrho0","logitrhoinf")]
  partabs<-t(partabs)
  #pb$tick()$print()
  return(partabs)
}
