#"Synchrony.External15_DD.Growth.R" is the last iteration with Climate included

## FUNCTIONS AND PACKAGES ####
library("ggplot2")
library(plyr)
library("dplyr")
library("reshape2")
library("marmap")
library("mvtnorm")
library("tidyr")
library(ggpubr)
library("GGally")
library(ggmap) # plot maps with ggplot
library(mapdata)
library(rsoi)
library(MuMIn)
library(rsoi)
library(stringr)
library(broom)
library("statmod")
library("mvtnorm")
library("marmap")
library(gstat)
library(metR)
library(ggpubr)
library(gstat)
library(directlabels)
library(ggridges)
library(flextable)
library(pals)
source("D:/Functions_USB.r")


land <- ggplot2::map_data("world2Hires")
land<-subset(land, (region %in% c("Norway", "USSR", "Sweden", "Finland", "Greenland")))

usespecies.df<-data.frame(#usespecies = list.files("C:/Users/jonatanf/Documents/update2019/Data/")[c(1,7, 16, 10, 19, 20, 13, 11, 18)],
  usespecies = c("¥YEPÅL", "GAPEFLYNDRE", "ROGNKJEKS","HYSE", "SNABELUER", "TORSK", "LODDE","KOLMULE", "SILD"),
  usespeciesENG = c("Pout","APlaice", "Lumpus", "Haddock", "B_redfish", "Cod", "Capelin",  "B_whiting", "Herring"),
  DepthAffinity = c("75",  "SBT",     "75",     "SBT",     "SBT",       "SBT", "30",       "75",  "30"))

####  PARAMETERS AND DATA ####
#Set boundaries for parameter values; only occasionally needed
With0<-FALSE
AgesToo<-FALSE
LengthsToo <-FALSE
FindBestEnvironemntalPredictor<-FALSE
DoVariogramAnalyses<-TRUE
DoVariogramAnalysesPerYear<-TRUE
Plot_K.Temp<-TRUE
Plot_K.withoutTemp<-FALSE
PlotBetas<-TRUE
DoSynchronies<-FALSE
PlotBetasWithR2<-FALSE

yrs<-1985:2016
av<-c(6400, 8100, 10000,12100, 14400)


Synch_Results<-data.frame()
SynchPoints<-data.frame()

# START AREA LOOP ####
a<-8100  
cat("\n Resolution: ", a,"\n")
Offs<-0


All_Yearly_vgmPoints<-data.frame()
All_Yearly_vgmLines<-data.frame()
V_Param<-data.frame()


load(file = "Resolutions_hexpoly.rda") # Resolutions_hexpoly
load(file = "Resolutions_list.rda") # Resolutions_list
# START SP LOOP ####
for(sp in (1:nrow(usespecies.df))){
  
  start_time <- Sys.time()
  
  art<-usespecies.df[sp, 1]
  species<-usespecies.df[sp, 2]
  depthi<-"SBT"
  cat(paste("Doing ", species, ": \n"))
  cat("loading data \n")
  # .Fish data ####
  cat(paste(sp, "/",nrow(usespecies.df)," species \n"))
  
  ###### #######  ###### #######  ###### #######  ###### #######  ###### #######  ###### ####### 3
  #          N & K          N & K           N & K           N & K           N & K           N & K
  # .N & K ####
  ###### #######  ###### #######  ###### #######  ###### #######  ###### #######  ###### #######3
  N_df<-Resolutions_list[[paste(8100)]][[paste(-0.1)]][[species]]
  hex_grid_LL_M<-Resolutions_hexpoly[[paste(8100)]][[paste(-0.1)]]
  
  
  N_df_2<-N_df[!is.na(N_df$Temperature) & !is.na(N_df$Depth) & !is.na(N_df$N),]
  N_df_2$Temperature_2<-N_df_2$Temperature^2
  
  
  N_T_lm<-lm(N ~ as.factor(Year) + (Temperature + Temperature_2), N_df_2)
  
  #summary(N_T_lm)
  
  Pred <- seq(min(N_df_2$Temperature), max(N_df_2$Temperature), 0.1)
  Pred_df <- predict(N_T_lm,
                     list(Temperature=rep(Pred, length(unique(N_df_2$Year))),
                          Temperature_2=rep(Pred^2, length(unique(N_df_2$Year))),
                          Year = rep(unique(N_df_2$Year), each = length(Pred))))
  Pred_df<-data.frame(Year = rep(unique(N_df_2$Year),each = length(Pred)),
                      Temperature = rep(Pred, length(unique(N_df_2$Year))), 
                      Temperature_2 = rep(Pred^2, length(unique(N_df_2$Year))), 
                      Predicted = Pred_df)
  
  #####
  
  DensityMap<-merge(hex_grid_LL_M_df, N_df_2, by.x = "id", by.y = "gridid")
  DensityMap<-DensityMap[order(DensityMap$id, DensityMap$order),]
  
  
  Plot<-ggplot()+
    geom_polygon(data = DensityMap , aes(x = long, y = lat, group = group, fill = N), size = 0.5, color="white") +
    geom_polygon(data = land, aes(x = long, y = lat, group=group), alpha= 0.2, color = "white", size = 0.3) +
    theme_classic()+
    coord_cartesian(xlim = c(13, 54), ylim= c(68, 77))+
    scale_fill_gradientn(colors = c("#eae2b7","#99d98c","#52b69a","#168aad","#1a759f","#184e77"))+
    theme(axis.title=element_blank(), legend.position = "bottom")+
    facet_wrap(~ Year)+
    ggtitle("N where there is Temperature data")
  
  
  Yearly_vgm<-data.frame()
  Yearly_vgmLines<-data.frame()
  
  
  N_df_2<-merge(N_df_2, data.frame(N_T_Res = round(residuals(N_T_lm),8)), by = "row.names", all.x = TRUE)
  N_df_2$Row.names<-NULL

  for(yr in 1986:2015){
    
    if(nrow(N_df_2[!is.na(N_df_2$Temperature) & N_df_2$Year == yr ,])>14){
      
      cat(paste(yr, "--> "))
       Residuals_m<-unique(N_df_2[N_df_2$Year == yr ,c('gridid', 'N')])
      
      Residuals_m<-Residuals_m[!is.na(Residuals_m$N),]
      #Residuals_m[,2]<-log( Residuals_m[,2])
      
      Dat<-merge(LL,data.frame(Residuals_m), by.x ="row.names", by.y = "gridid" )
      Points <- SpatialPointsDataFrame(Dat[,c('x', 'y')], Dat)
      proj4string(Points)<- CRS("+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs +towgs84=0,0,0")
      
      gv_K<-gstat::variogram(N~1, Points, cutoff = max(pointDistance(Points), na.rm = TRUE)/1000)#,ma
      

      g0v.fit<-fit.variogram(gv_K, vgm(NA, paste("Gau"), NA ))
      V_Param<-rbind(V_Param, data.frame("Nugget" = 0,"Sill" = g0v.fit[1,2], "Range" = g0v.fit[1,3], Species = species, Year = yr, Data = "e.N", Method= "Gau_0"))
      g0V_Line_K<-data.frame(variogramLine(g0v.fit, dist_vector = seq(5, max(gv_K$dist), 5)))
      Yearly_vgmLines<-rbind(Yearly_vgmLines, data.frame(g0V_Line_K, Data = "e.N", Year = yr, method = "Gau_0"))

      
      Yearly_vgm<-rbind(Yearly_vgm, data.frame(gv_K, Data = "N", Year = yr))
      
      

      Residuals_m<-unique(N_df_2[N_df_2$Year == yr ,c('gridid', 'N_T_Res')])
      
      Residuals_m<-Residuals_m[!is.na(Residuals_m$N_T_Res),]
      
      
      Dat<-merge(LL,data.frame(Residuals_m), by.x ="row.names", by.y = "gridid" )
      Points <- SpatialPointsDataFrame(Dat[,c('x', 'y')], Dat)
      proj4string(Points)<- CRS("+proj=longlat +ellps=WGS84 +datum=WGS84 +no_defs +towgs84=0,0,0")
      
      gV_K.T2<-gstat::variogram(N_T_Res~1, Points, cutoff = max(pointDistance(Points), na.rm = TRUE)/1000)#,ma
    
      
      g0v.fit<-fit.variogram(gV_K.T2, vgm(NA, paste("Gau"), NA ))
      V_Param<-rbind(V_Param, data.frame("Nugget" = 0,"Sill" = g0v.fit[1,2], "Range" = g0v.fit[1,3], Species = species, Year = yr, Data = "winter temperature", Method= "Gau_0"))
      g0V_Line_K<-data.frame(variogramLine(g0v.fit, dist_vector = seq(5, max(gV_K.T2$dist), 5)))
      Yearly_vgmLines<-rbind(Yearly_vgmLines, data.frame(g0V_Line_K, Data = "winter temperature", Year = yr, method = "Gau_0"))

      
      Yearly_vgm<-rbind(Yearly_vgm, data.frame(gV_K.T2, Data = "winter temperature", Year = yr))
      
    }else{
      Yearly_vgm<-rbind(Yearly_vgm, NA)
      
      Yearly_vgm$Year[nrow(Yearly_vgm)]<-yr
    }
  }
  
  # VARIOGRAMS
  Plot<-ggplot(Yearly_vgm)+
    geom_point(aes(dist, gamma, color = Data))+
    geom_line(data = Yearly_vgmLines[Yearly_vgmLines$method == "Gau_0",], aes(dist, gamma, color= Data))+
    facet_wrap(~Year, ncol = 5)+
    theme_classic()+
    theme(legend.position = "bottom")+
    coord_cartesian(ylim = c(0, (max(Yearly_vgmLines[Yearly_vgmLines$method == "Gau_0",]$gamma)*1.1)), expand = FALSE)
  
  
}
##########################
# PROPORTION AUTOCORRELATION RELATED TO TEMPERATURE
V_Param_temp <- V_Param[V_Param$Method == "Gau_0" & V_Param$Data %in% c("e.N", "winter temperature") ,]


V_Param_temp<-merge(V_Param_temp[V_Param_temp$Data =="e.N",2:5], V_Param_temp[V_Param_temp$Data =="winter temperature",2:5], by = c("Species", "Year"))
colnames(V_Param_temp)<-c("Species", "Year", "Sill_N", "Range_N", "Sill_Temp", "Range_Temp")

V_Param_temp$Sill_Diff<-V_Param_temp$Sill_Temp/V_Param_temp$Sill_N
V_Param_temp$Range_Diff<-V_Param_temp$Range_Temp/V_Param_temp$Range_N 

V_Param_temp$Sill_Diff<- (V_Param_temp$Sill_N - V_Param_temp$Sill_Temp) / V_Param_temp$Sill_N
V_Param_temp$Range_Diff<- (V_Param_temp$Range_N - V_Param_temp$Range_Temp) / V_Param_temp$Range_N 


V_Param_temp[V_Param_temp$Species == "APlaice",'Species']<-"Long rough dab"
V_Param_temp[V_Param_temp$Species == "B_redfish",'Species']<-"Beaked redfish"
V_Param_temp[V_Param_temp$Species == "B_whiting",'Species']<-"Blue whiting"
V_Param_temp[V_Param_temp$Species == "Lumpus",'Species']<-"Lumpfish"
V_Param_temp[V_Param_temp$Species == "Pout",'Species']<-"Norway pout"

V_Param_temp$Species <- factor(V_Param_temp$Species, levels = c("Norway pout","Blue whiting","Beaked redfish","Haddock","Cod","Capelin","Lumpfish","Long rough dab","Herring"))

temp_NA<-data.frame(table(V_Param_temp$Species, V_Param_temp$Year))
temp_NA<-temp_NA[temp_NA$Freq == 0,]

V_Param_temp<-rbind(V_Param_temp, data.frame(Species = temp_NA$Var1, Year = as.numeric(paste(temp_NA$Var2)), Sill_N =NA,   Range_N =NA,  Sill_Temp =NA,  Range_Temp =NA,  Sill_Diff =NA,  Range_Diff =NA )) 

Plot1<-
  ggplot(V_Param_temp, aes(Year, Sill_Diff))+
  facet_wrap(~Species)+
  geom_hline(yintercept = 0, linetype = "dotted") +
  theme_classic()+
  scale_y_continuous(breaks = seq(0,1,0.2),  expand = c(0, 0))+
  scale_x_continuous(breaks = seq(1990,2015,5))+
  geom_line()+
  theme(legend.position = "top", strip.background = element_rect(color=NA, fill=NA))+labs(y = "Proportion")+
  labs(y = "Proportion")


Plot2<-
  ggplot(V_Param_temp, aes(Year, Range_Diff))+
  facet_wrap(~Species)+
  geom_hline(yintercept = 0, linetype = "dotted") +
  theme_classic()+
  scale_y_continuous(breaks = seq(0,1,0.2),  expand = c(0, 0))+
  scale_x_continuous(breaks = seq(1990,2015,5))+
  geom_line()+
  theme(legend.position = "top", strip.background = element_rect(color=NA, fill=NA))+labs(y = "Proportion")+
  labs(y = "Proportion")



Plot<-ggarrange(Plot1, Plot2, ncol = 1, labels = c("a", "b"))
