#"Synchrony.External15_DD.Growth.R" is the last iteration with Climate included

## FUNCTIONS AND PACKAGES ####
library("ggplot2")
library(plyr)
library("dplyr")
library("reshape2")
library("marmap")
library("mvtnorm")
library("tidyr")
library(ggpubr)
library("GGally")
library(ggmap) # plot maps with ggplot
library(mapdata)
library(rsoi)
library(MuMIn)
library(rsoi)
library(stringr)
library(broom)
library("statmod")
library("mvtnorm")
library("marmap")
library(gstat)
library(metR)
library(ggpubr)
library(gstat)
library(directlabels)
library(ggridges)
source("D:/Functions_USB.r")

Sys.setlocale(locale='no_NB.utf8')
land <- ggplot2::map_data("world2Hires")
land<-subset(land, (region %in% c("Norway", "USSR", "Sweden", "Finland", "Greenland")))

usespecies.df<-data.frame(usespecies = c("¥YEPÅL", "GAPEFLYNDRE", "ROGNKJEKS","HYSE", "SNABELUER", "TORSK", "LODDE","KOLMULE", "SILD"),
                          usespeciesENG = c("Pout","APlaice", "Lumpus", "Haddock", "B_redfish", "Cod", "Capelin",  "B_whiting", "Herring"),
                          DepthAffinity = c("75",  "SBT",     "75",     "SBT",     "SBT",       "SBT", "30",       "75",  "30"))

Max_nboots<-10 # number bootstraps
start.val=c(Logit(.5),Logit(.1),log(500))


####  PARAMETERS AND DATA ####
#Set boundaries for parameter values; only occasionally needed
With0<-FALSE
AgesToo<-FALSE
LengthsToo<-FALSE
DoVariogramAnalyses<-TRUE
DoVariogramAnalysesPerYear<-TRUE
Plot_K.Temp<-FALSE
Plot_K.withoutTemp<-FALSE
PlotBetas<-TRUE
DoSynchronies<-TRUE
PlotBetasWithR2<-FALSE

yrs<-1985:2016
av<-c(6400, 8100, 10000,12100) # Grid resolution km2


Synch_Results<-data.frame()
SynchPoints<-data.frame()

All_Yearly_vgmPoints<-data.frame()
All_Yearly_vgmLines<-data.frame()
V_Param<-data.frame()

All_data<-list()
# START AREA LOOP ####

Offsets<-seq(-0.1, -3.1, -0.25)


load(file = "Resolutions_hexpoly.rda") # Resolutions_hexpoly
load(file = "Resolutions_list.rda") # Resolutions_list


for(a in av){
    cat("\n Resolution: ", a,"\n")
  for(Offs in Offsets){
    cat("\nOffseting by", Offs,"\n")

    # START SP LOOP ####
    for(sp in (1:nrow(usespecies.df))){
      start_time <- Sys.time()
      
      art<-usespecies.df[sp, 1]
      species<-usespecies.df[sp, 2]
      depthi<-"SBT"
      cat(paste("Working on ", species, ": \n"))
      cat("loading data \n")
      
      # load data set ####
      N_df<-Resolutions_list[[paste(a)]][[paste(Offs)]][[species]]
      
      hex_grid_LL_M<-Resolutions_hexpoly[[paste(a)]][[paste(Offs)]]
      HexCentroids<-coordinates(hex_grid_LL_M)
      hex_grid_LL_M_df<-fortify(hex_grid_LL_M)
      
      zu<-pointDistance(HexCentroids, lonlat = TRUE)/1000
      zu[upper.tri(zu)] <- t(zu)[upper.tri(zu)]
       row.names(zu)<-colnames(zu)<-rownames(HexCentroids)
     
      ###########################################################################################################
      ###########################################################################################################
      ###########################################################################################################
      ###########################################################################################################3
      # K ANALYSES ####
      Temp_Fish_Data_temp<-N_df[!is.na(N_df$Depth) & !is.na(N_df$K),]
      Temp_Fish_Data_temp<-Temp_Fish_Data_temp[Temp_Fish_Data_temp$Depth == "SBT",]
      
      Temp_Fish_Data_temp$MeanTemp2<- Temp_Fish_Data_temp[,"Mean_Temperature_eN"]^2
      
      ##########################################################################################3
      # BETAS     BETAS     BETAS     BETAS     BETAS     BETAS     BETAS
      #       BETAS   ####
      ##########################################################################################3
      ###  ...Filter ####
      # Temperature data                ####3
      
      Temp_Fish_Data_temp<-N_df[!is.na(N_df$Delta),]
      temp_Temperature_df<-Temp_Fish_Data_temp[Temp_Fish_Data_temp$Depth == "SBT",]
      temp_Temperature_df<-temp_Temperature_df[!is.na(temp_Temperature_df$gridid),]
      #temp_df<-temp_df[!is.na(temp_df[,"Temperature"]),]
      #      xsampled<-data.frame(table(temp_df$gridid))
      #      temp_Temperature_df<-temp_df[temp_df$gridid %in% xsampled[xsampled$Freq>5,'Var1'],]
      
      # ...Models ####
      ######################################################################3
      #             ......Temperature              #####
      ######################################################################3
      # WINTER
      temp_temp_Temperature_df<-temp_Temperature_df[!is.na(temp_Temperature_df[,"Temperature"]),]
      xsampled<-data.frame(table(temp_temp_Temperature_df$gridid))
      temp_temp_Temperature_df<-temp_temp_Temperature_df[temp_temp_Temperature_df$gridid %in% xsampled[xsampled$Freq>5,'Var1'],]
      
      Temp_Model<-lm(Delta ~  as.factor(gridid) * Temperature, temp_temp_Temperature_df)
      temp_Temperature_df<-merge(temp_Temperature_df, data.frame(Res.D_Temp = residuals(Temp_Model)), by = "row.names", all.x =TRUE)
      temp_Temperature_df<-temp_Temperature_df[order(as.numeric(temp_Temperature_df$Row.names)),]
      temp_Temperature_df$Row.names<-NULL
      BaseSlope<-coefficients(Temp_Model)[names(coefficients(Temp_Model)) ==  'Temperature']
      Betas<-coefficients(Temp_Model)[str_split_fixed(names(coefficients(Temp_Model)), ":", 2)[,2] == "Temperature"]
      Temperature_Betas<-data.frame(gridid = Temp_Model$xlevels[[1]],
                                    Temperature_Betas= c(BaseSlope, BaseSlope+Betas))
      temp_Temperature_df<-merge(temp_Temperature_df, Temperature_Betas, by = "gridid", all.x =TRUE)
      
      # SUMMER
      temp_temp_Temperature_df<-temp_Temperature_df[!is.na(temp_Temperature_df[,"LastSummer_Temperature"]),]
      xsampled<-data.frame(table(temp_temp_Temperature_df$gridid))
      temp_temp_Temperature_df<-temp_temp_Temperature_df[temp_temp_Temperature_df$gridid %in% xsampled[xsampled$Freq>5,'Var1'],]
      
      Temp_Model<-lm(Delta ~  as.factor(gridid) * LastSummer_Temperature, temp_temp_Temperature_df)
      temp_Temperature_df<-merge(temp_Temperature_df, data.frame(Res.D_STemp = residuals(Temp_Model)), by = "row.names", all.x =TRUE)
      temp_Temperature_df<-temp_Temperature_df[order(as.numeric(temp_Temperature_df$Row.names)),]
      temp_Temperature_df$Row.names<-NULL
      BaseSlope<-coefficients(Temp_Model)[names(coefficients(Temp_Model)) == 'LastSummer_Temperature']
      Betas<-coefficients(Temp_Model)[str_split_fixed(names(coefficients(Temp_Model)), ":", 2)[,2] == "LastSummer_Temperature" ]
      Temperature_Betas<-data.frame(gridid = Temp_Model$xlevels[[1]],
                                    SummerTemperature_Betas= c(BaseSlope, BaseSlope+Betas))
      temp_Temperature_df<-merge(temp_Temperature_df, Temperature_Betas, by = "gridid", all.x =TRUE)
      
      #################################################################33
      #             ......Density  ########
      ######################################################################3
      temp_temp_Temperature_df<-temp_Temperature_df[!is.na(temp_Temperature_df[,"N"]),]
      xsampled<-data.frame(table(temp_temp_Temperature_df$gridid))
      temp_temp_Temperature_df<-temp_temp_Temperature_df[temp_temp_Temperature_df$gridid %in% xsampled[xsampled$Freq>5,'Var1'],]
      
      mod<-lm(Delta ~ as.factor(gridid) * N, temp_temp_Temperature_df)
      temp_Temperature_df<-merge(temp_Temperature_df, data.frame(Res.D_dd = residuals(mod)), by = "row.names", all.x =TRUE)
      temp_Temperature_df<-temp_Temperature_df[order(as.numeric(temp_Temperature_df$Row.names)),]
      temp_Temperature_df$Row.names<-NULL
      
      #BETA TEMP
      BaseSlopeDD<-coefficients(mod)[names(coefficients(mod)) == "N"]
      BetasDD<-coefficients(mod)[str_split_fixed(names(coefficients(mod)), ":", 2)[,2]  == "N"]
      DD_Betas<-data.frame(gridid = mod$xlevels[[1]],
                           dd_DD_Beta= c(BaseSlopeDD, BaseSlopeDD+BetasDD))
      temp_Temperature_df<-merge(temp_Temperature_df, DD_Betas, by = "gridid", all.x =TRUE)
      
      #################################################################33
      #             ......BOTH          ########
      #             ......Winter temp  ########
      ######################################################################3
      temp_temp_Temperature_df<-temp_Temperature_df[!is.na(temp_Temperature_df[,"Temperature"]),]
      xsampled<-data.frame(table(temp_temp_Temperature_df$gridid))
      temp_temp_Temperature_df<-temp_temp_Temperature_df[temp_temp_Temperature_df$gridid %in% xsampled[xsampled$Freq>5,'Var1'],]
      
      Temp_Model<-lm(Delta ~ as.factor(gridid) * N + as.factor(gridid) * Temperature, temp_temp_Temperature_df)
      temp_Temperature_df<-merge(temp_Temperature_df, data.frame(Res.D_ddTemp = residuals(Temp_Model)), by = "row.names", all.x =TRUE)
      temp_Temperature_df<-temp_Temperature_df[order(as.numeric(temp_Temperature_df$Row.names)),]
      temp_Temperature_df$Row.names<-NULL
      
      
      BaseSlopeTemp<-coefficients(Temp_Model)[names(coefficients(Temp_Model)) == 'Temperature']
      BetasTemp<-coefficients(Temp_Model)[str_split_fixed(names(coefficients(Temp_Model)), ":", 2)[,2] == "Temperature"]
      
      BaseSlopeDD<-coefficients(Temp_Model)[names(coefficients(Temp_Model)) == "N"]
      BetasDD<-coefficients(Temp_Model)[str_split_fixed(names(coefficients(Temp_Model)), ":", 2)[,2]  == "N"]
      
      Temperature_Betas<-data.frame(gridid = Temp_Model$xlevels[[1]],
                                    dd_Temp.ddwt_Beta= c(BaseSlopeTemp, BaseSlopeTemp+BetasTemp),
                                    dd_DD.ddwt_Beta= c(BaseSlopeDD, BaseSlopeDD+BetasDD))
      
      temp_Temperature_df<-merge(temp_Temperature_df, Temperature_Betas, by = "gridid", all.x = TRUE)
      
      
      
      ############################################################################3
      #  SYNCHRONY   SYNCHRONY    SYNCHRONY    SYNCHRONY    SYNCHRONY    SYNCHRONY    ####3
      # SYNCHRONY ####
      ############################################################################3
      
      cat("Starting spatial synchrony analyses \n")
      
      
      #  ...Without density regulation    ####
      cat("\nDensity reg. \n")
      ###########################################################################3
      nboots <- Max_nboots #- XXX[XXX$Var1 == a & XXX$Var2 == Offs& XXX$Var4 == species & XXX$Var3 == "dd_NA",'Freq']
      if(nboots <1){nboots = 10}
      Residuals_m<-dcast(temp_Temperature_df, Year ~ gridid, value.var = "Res.D_dd")
      row.names(Residuals_m)<-Residuals_m[,1]
      Residuals_m<-Residuals_m[,-1]
      zu.temp<-zu[row.names(zu) %in% colnames(Residuals_m), colnames(zu) %in% colnames(Residuals_m)]
      Residuals_m<-Residuals_m[ ,colnames(zu.temp)]
      lower<-c(-10, -10, log(sqrt(a)))
      upper<-c(10, 10, log(max(zu.temp)))
      Residuals_m<-scale(Residuals_m, center = FALSE)
      #start_time <- Sys.time()
      outputv<-nlminb(start.val, lls, x=Residuals_m, distmat=zu.temp, lower=lower, upper=upper)
      parsV <- data.frame(rho.0=exp(outputv$par[1])/(1+exp(outputv$par[1])),
                          rho.inf=exp(outputv$par[1])/(1+exp(outputv$par[1]))* exp(outputv$par[2])/(1+exp(outputv$par[2])),
                          lambda=exp(outputv$par[3]))
      
      Boots.yu<-par.boot(data = Residuals_m, zu.temp, rho.0= parsV$rho.0,  rho.inf= parsV$rho.inf, lambda= parsV$lambda, bt= nboots)
      Synch_D_dd <- furrr::future_map(Boots.yu, function(x) boot.nlminb(x), .progress = TRUE)
      SynchPoints.temp<-cor.overlap(Residuals_m, n = 5)
      SynchPoints.temp<-merge(SynchPoints.temp$Output, melt(zu.temp), by = c("Var1", "Var2"))
      colnames(SynchPoints.temp)<-c("From", "To", "rho", "Distance")
      SynchPoints<-rbind(SynchPoints, data.frame(SynchPoints.temp[,3:4], Species = species, Stage = "Population", Resolution = a, Offset = Offs, Data = "dd", Season = NA, Depth = NA))
      
      #  ...WIthout density reg. + temperature ####
      cat("\nDensity reg. + Temperature\n")
      ############################################################################  3
      if(nboots <1){nboots = 10}
      Residuals_m<-dcast(temp_Temperature_df, Year ~ gridid, value.var = "Res.D_ddTemp")
      
      row.names(Residuals_m)<-Residuals_m[,1]
      Residuals_m<-Residuals_m[,-1]
      
      zu.temp<-zu[row.names(zu) %in% colnames(Residuals_m), colnames(zu) %in% colnames(Residuals_m)]
      Residuals_m<-Residuals_m[ ,colnames(zu.temp)]
      
      Residuals_m<-scale(Residuals_m, center = FALSE)
      
      outputv<-nlminb(start.val[1:3],lls, x=Residuals_m, distmat=zu.temp, lower=lower,upper=upper)
      parsV <- data.frame(rho.0=exp(outputv$par[1])/(1+exp(outputv$par[1])),
                          rho.inf=exp(outputv$par[1])/(1+exp(outputv$par[1]))* exp(outputv$par[2])/(1+exp(outputv$par[2])),
                          lambda=exp(outputv$par[3]))
      
      Boots.yu<-par.boot(data = Residuals_m, zu.temp, rho.0= parsV$rho.0,  rho.inf= parsV$rho.inf, lambda= parsV$lambda, bt= nboots)
      Synch_D_ddTemp <- furrr::future_map(Boots.yu, function(x) boot.nlminb(x), .progress = TRUE)
      
      
      SynchPoints.temp<-cor.overlap(Residuals_m, n = 5)
      SynchPoints.temp<-merge(SynchPoints.temp$Output, melt(zu.temp), by = c("Var1", "Var2"))
      colnames(SynchPoints.temp)<-c("From", "To", "rho", "Distance")
      SynchPoints<-rbind(SynchPoints, data.frame(SynchPoints.temp[,3:4], Species = species, Stage = "Population2", Resolution = a, Offset = Offs, Data = "ddTemp", Season = "Winter", Depth = "SBT"))
      
      
      #  ...Without temperature ####
      cat("\nWinter Temperature\n")
      ############################################################################ 3
      if(nboots <1){nboots = 10}
      Residuals_m<-dcast(temp_Temperature_df, Year ~ gridid, value.var = "Res.D_Temp")
      
      row.names(Residuals_m)<-Residuals_m[,1]
      Residuals_m<-Residuals_m[,-1]
      
      zu.temp<-zu[row.names(zu) %in% colnames(Residuals_m), colnames(zu) %in% colnames(Residuals_m)]
      Residuals_m<-Residuals_m[ ,colnames(zu.temp)]
      
      Residuals_m<-scale(Residuals_m, center = FALSE)
      
      outputv<-nlminb(start.val[1:3],lls, x=Residuals_m, distmat=zu.temp, lower=lower,upper=upper)
      parsV <- data.frame(rho.0=exp(outputv$par[1])/(1+exp(outputv$par[1])),
                          rho.inf=exp(outputv$par[1])/(1+exp(outputv$par[1]))* exp(outputv$par[2])/(1+exp(outputv$par[2])),
                          lambda=exp(outputv$par[3]))
      
      Boots.yu<-par.boot(data = Residuals_m, zu.temp, rho.0= parsV$rho.0,  rho.inf= parsV$rho.inf, lambda= parsV$lambda, bt= nboots)
      Synch_D_Temp <- furrr::future_map(Boots.yu, function(x) boot.nlminb(x), .progress = TRUE)
      
      
      SynchPoints.temp<-cor.overlap(Residuals_m, n = 5)
      SynchPoints.temp<-merge(SynchPoints.temp$Output, melt(zu.temp), by = c("Var1", "Var2"))
      colnames(SynchPoints.temp)<-c("From", "To", "rho", "Distance")
      SynchPoints<-rbind(SynchPoints, data.frame(SynchPoints.temp[,3:4], Species = species, Stage = "Population", Resolution = a, Offset = Offs, Data = "Temp", Season = "Winter", Depth = "SBT"))
      
      
      
      #  ...Delta ####
      cat("\nDelta\n")
      ############################################################################3
      if(nboots <1){nboots = 1}
      Temp_Fish_Data_temp<-N_df[!is.na(N_df$Delta),]
      temp_df<-Temp_Fish_Data_temp[Temp_Fish_Data_temp$Depth == "SBT",]
      Delta_m<-dcast(temp_df[!is.na(temp_df$Delta),], Year ~ gridid, value.var = "Delta")
      
      row.names(Delta_m)<-Delta_m[,1]
      Delta_m<-Delta_m[,-1]
      
      zu.temp<-zu[row.names(zu) %in% colnames(Delta_m), colnames(zu) %in% colnames(Delta_m)]
      Delta_m<-Delta_m[ ,colnames(zu.temp)]
      
      Delta_m<-scale(Delta_m, center = FALSE)
      
      
      outputv<-nlminb(start.val,lls, x=Delta_m, distmat=zu.temp, lower=lower,upper=upper)
      parsV <- data.frame(rho.0=exp(outputv$par[1])/(1+exp(outputv$par[1])),
                          rho.inf=exp(outputv$par[1])/(1+exp(outputv$par[1]))* exp(outputv$par[2])/(1+exp(outputv$par[2])),
                          lambda=exp(outputv$par[3]))
      
      Boots.yu<-par.boot(data = Delta_m, zu.temp, rho.0= parsV$rho.0,  rho.inf= parsV$rho.inf, lambda= parsV$lambda, bt= nboots)
      Synch_Delta <- furrr::future_map(Boots.yu, function(x) boot.nlminb(x), .progress = TRUE)
      
      SynchPoints.temp<-cor.overlap(Delta_m, n = 5)
      SynchPoints.temp<-merge(SynchPoints.temp$Output, melt(zu.temp), by = c("Var1", "Var2"))
      colnames(SynchPoints.temp)<-c("From", "To", "rho", "Distance")
      SynchPoints<-rbind(SynchPoints, data.frame(SynchPoints.temp[,3:4], Species = species, Stage = "Population", Resolution = a, Offset = Offs, Data = "Delta", Season = NA, Depth = NA))
      

      #################################################################################3
      #################################################################################3
      # COMPILING COMPILING COMPILING COMPILING COMPILING COMPILING COMPILING COMPILING
      # COMPILING ####
      #################################################################################3
      #################################################################################3
      cat("\n")
      cat("Compiling results")
      
      
      
      SynchResults.temp <- rbind(data.frame(do.call(rbind, Synch_Delta), Data = "Delta", Species = species, Stage = "Population", Offset = Offs, Resolution = a, BestModel = NA, BestClim = NA, BestTemperature = NA, BestDepth = NA),
                                 data.frame(do.call(rbind, Synch_D_dd), Data = "dd", Species = species, Stage = "Population", Offset = Offs, Resolution = a, BestModel = NA, BestClim = NA, BestTemperature = NA, BestDepth = NA),
                                 data.frame(do.call(rbind, Synch_D_Temp), Data = "Temp", Species = species, Stage = "Population", Offset = Offs, Resolution = a, BestModel = Best_Delta.TemperatureModel, BestClim = NA, BestTemperature = Best_Temperature_Season, BestDepth = "SBT"),
                                 
                                 data.frame(do.call(rbind, Synch_D_ddTemp), Data = "ddTemp", Species = species, Stage = "Population", Offset = Offs, Resolution = a, BestModel = Best_Delta.TemperatureModel, BestClim = NA, BestTemperature = Best_Temperature_Season, BestDepth = "SBT")
      )
      
      SynchResults.temp[,1]<-as.numeric(SynchResults.temp[,1])
      SynchResults.temp[,2]<-as.numeric(SynchResults.temp[,2])
      SynchResults.temp[,3]<-as.numeric(SynchResults.temp[,3])
      
      #
      SynchResults.temp$logitrhoinf <- InvLogit(SynchResults.temp$logitrho0)*InvLogit(SynchResults.temp$logitrhoinf)
      SynchResults.temp$logitrho0 <- InvLogit(SynchResults.temp$logitrho0)
      SynchResults.temp$logl <- exp(SynchResults.temp$logl)
      
      
      Synch_Results<-rbind(Synch_Results, SynchResults.temp)
      
    } # CLOSES SP
  } # CLOSES Offs
} #CLOSES AREA 


# SAVING ####
save(Synch_Results, file = "Synch_Results.rda")
save(SynchPoints, file = "Synch_Points.rda")



table(Synch_Results$Resolution,Synch_Results$BestDepth, Synch_Results$Offset)


